<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :offsetArrow="20" :spanTitle="3" title="Ir a Materiales" v-on:clickEvent="viewListReview" style="margin-bottom:2.5rem"></ReturnButton>
        <el-row :gutter="20">
        <!-- FILTROS DE BUSQUEDA --> 
          <el-col :span="18" class="text-end">
            <app-select v-model="filterSelect" :filterArray="allFilters"></app-select>
          </el-col>
          <el-col :span="6">
            <app-search-filter v-model="textSearch"></app-search-filter>
          </el-col>  
      </el-row>
    </header>

    <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem 4rem">
      <Title :Title="'REVISION DE ' + matType + ' - '+ typeMaterialR.toUpperCase()"> </Title>
    </div>
    <!-- Leyenda -->
    <div style="margin:3rem 6rem">
      <DescriptionStateOrders 
        TextSquareGray="Sin Revisar"
        :TextSquarePurple="''"
        TextSquareGreen="Revisión Aprobada" 
        :TextSquareBlue="''" 
        :TextSquareRed="'Pendiente de Reposición'"  
        :TextSquareOrange="'Datos Incompletos'" :colBoxes="6"> </DescriptionStateOrders>
    </div>

    <el-main style="margin:3rem 5rem">
      <el-row>
        <!-- :detailsData="{
                              0:{subtitle: 'Código de Material', content: material.codMaterial},
                              1:{subtitle: 'Proveedor', content: material.providerName},
                              2:{subtitle: 'Cod. Proveedor', content: material.providerCode},
                              3:{subtitle: 'Cod. Contrato', content: material.contractCode},
                            }"
                            :detailsData2="{
                              0:{subtitle: 'Género', content: (material.reviewObj)?(material.reviewObj.genre2)?(material.reviewObj.genre1)?material.reviewObj.genre1+ ' / ' + material.reviewObj.genre2:material.reviewObj.genre2:material.reviewObj.genre1:''},
                              1:{subtitle: 'Clasificación', content: (material.reviewObj)?material.reviewObj.classification:''},
                              2:{subtitle: 'Etiquetas', content: Array(Object(material.reviewObj).dynamicTags).join(', ') },
                              3:{subtitle: 'Actores', content: (material.reviewObj)?(material.reviewObj.artisticInfo)?Array(material.reviewObj.artisticInfo[0].mainActors).join(', '):'':''},
                            }" -->
        <el-col 
          v-for="(material, index) in materials.slice(0,30)"
          :key="index"
          :span="18" :offset="3"
          style="margin-bottom: 4rem">
          <app-card-review :itemPrincipal="material" :rutaImg="require(`../../../assets/images/icono-miniserie.svg`)" :shadowBox="'purple-shadow'" :imgStyle="'icon-card'" :cannedView="canned" :showRate="true"
                            :detailsData="{
                              0:{subtitle: 'Código de Material', content: material.codMaterial},
                              1:{subtitle: 'Proveedor', content: material.providerName},
                              2:{subtitle: 'Cod. Proveedor', content: material.providerCode},
                              3:{subtitle: 'Cod. Contrato', content: material.contractCode},
                            }"
                            :detailsData2="{
                              0:{subtitle: 'Género', content: (material.reviewObj)?(material.reviewObj.genre2)?(material.reviewObj.genre1)?material.reviewObj.genre1+ ' / ' + material.reviewObj.genre2:material.reviewObj.genre2:material.reviewObj.genre1:''},
                              1:{subtitle: 'Clasificación', content: (material.reviewObj)?material.reviewObj.classification:''},
                              2:{subtitle: 'Etiquetas', content: Array(Object(material.reviewObj).dynamicTags).join(', ') },
                              3:{subtitle: 'Actores', content: material.reviewObj && material.reviewObj.artisticInfo ? material.reviewObj.artisticInfo[0].mainActors.join(', ') : ''},
                            }"
                            :btnGroup="{
                              0:{validationBtnShow: material.reviewStatus === 'withoutChecking', btnClass: 'border-grey-darken text-dark-gray-2', btnTextAction: 'SIN REVISAR', editVal: 'selectedMaterial', newVal: 'revision'},  
                              1:{validationBtnShow: material.reviewStatus === 'approved', btnClass: 'border-green text-green', btnTextAction: 'APROBADO', editVal: 'selectedMaterial', newVal: 'report'},
                              2:{validationBtnShow: material.reviewStatus === 'pending', btnClass: 'border-red text-red', btnTextAction: 'PENDIENTE', editVal: 'selectedMaterial', newVal: 'report'},
                              3:{validationBtnShow: material.reviewStatus === 'incomplete', btnClass: 'border-orange text-orange', btnTextAction: 'INCOMPLETO', editVal: 'selectedMaterial', newVal: 'report'}
                            }"/>
        </el-col>
      </el-row>
    </el-main>
    
  </div>
</template>

<script>
// @ is an alias to /src
import SearchFilter from '@/components/searchFilter.vue'
import Select from '@/components/AppSelect.vue'
import ReturnButton from '@/components/ReturnButton.vue'
import { modifyText } from '../../../utils/modifyText.js'
import CardReview from '@/components/cardReview'
import Title from '@/components/Title.vue'  
import DescriptionStateOrders from '@/components/DescriptionStateOrders.vue'
import { HTTP } from '../../../main.js'

export default {
  components: {
    ReturnButton,
    'app-search-filter': SearchFilter,
    'app-select': Select,
    'app-card-review': CardReview,
    Title,
    DescriptionStateOrders,
  },
  data () {
    return {
      canned: false,
      returnButtonModal: false,
      filterSelect: '',
      textSearch: '',
      allFilters: [
        {value: 'providerName', label: 'Proveedor'},
        {value: 'codMaterial', label: 'Código de Material'}
      ],
      typeMaterialR: localStorage.getItem('typeMaterialR'),
      arrMaterial: '',
      matType: localStorage.getItem('classification'),
      affiliate: '',
    }
  },
  created () {
    this.canned = this.$route.params.canned
    this.affiliate = JSON.parse(this.$localStorage.get('afiliado'))
    this.getMaterial(this.typeMaterialR, 'arrMaterial')
  },
  computed: {
    materials () {
      let miniseries = this.arrMaterial

      if (this.textSearch) {
        miniseries = this.arrMaterial.filter(
          m => modifyText(m.originalTitle).indexOf(modifyText(this.textSearch)) > -1 ||
                modifyText(m.ownTitle).indexOf(modifyText(this.textSearch)) > -1 ||
                modifyText(m.listTitle).indexOf(modifyText(this.textSearch)) > -1 
        )
      }

      if (this.filterSelect && this.textSearch) {
        miniseries = this.arrMaterial.filter(
          m => modifyText(m[this.filterSelect]).indexOf(modifyText(this.textSearch)) !== -1)
      }

      // this.sortArray(miniseries)
      // miniseries.sort(function (a, b) {
      //   if (a.geminisCode > b.geminisCode) {
      //     return 1;
      //   }
      //   if (a.geminisCode < b.geminisCode) {
      //     return -1;
      //   }
      //   // a must be equal to b
      //   return 0;
      // });
      
      
      return miniseries
    }
  },
  methods: {
    orderDataByGeminisCode (array) {
      array.sort(function (a, b) {
        if ( Number(a.geminisCode) < Number(b.geminisCode) ) {
          return 1;
        }
        if ( Number(a.geminisCode) > Number(b.geminisCode )) {
          return -1;
        }
        return 0;
      });
      return array
    },
    getMaterialsDeAfiliado(material, arr) {
      HTTP.get('materials/materialType/Televisa/typeOfContent/' + material + '/canned/true')
      .then(res => {
        let arrOfMaterial = res.data.materials
        let materialsToShow = []
        arrOfMaterial.map(el => {
          if(el.providerName !== ''){
            materialsToShow.push(el)
          }
        })
        this[arr] = this.orderDataByGeminisCode(materialsToShow)
      })
      .catch(err => console.log(err))
    },
    getMaterial(material, arr) {
      
      if(this.canned){
        if(this.affiliate){
          this.getMaterialsDeAfiliado(this.typeMaterialR, arr)
        } else {
          this[arr] = this.orderDataByGeminisCode(this.$store.state[this.typeMaterialR]) 
        }
      } else{
        
        HTTP.get('/materials/materialType/Producción Nacional/typeOfContent/'+material+'/canned/false')
          .then(res => {
            this[arr] = res.data.materials
          })
          .catch(err => {
            console.log(err);
          });
        this[arr] = this.orderDataByGeminisCode(JSON.parse(sessionStorage.getItem( this.typeMaterialR ))) 
        console.log('produccion nacional')
      }
        
    },
    viewListReview () {
      if(this.canned){
        if(this.affiliate){
          this.$router.push({name: 'revAfiliadoTelevisa', params: { canned: true }})
        }else{
          this.$router.push({name: 'materialesEnlatados', params: { canned: true }})
        }
      } else{
        this.$router.push({name: 'produccionNacional', params: { canned: false } })
      }
    },
    sortArray(arrayOrder) {
      arrayOrder.sort(function(a, b) {
      return a.geminisCode - b.geminisCode;
    });
    }
    
  }
}
</script>

<style>
.purple-shadow{
  box-shadow: 5px 5px 10px #4f30764a !important;
}
</style>
